<?php
// $Id: uc_customquote.admin.inc,v 1.1.2.8 2010/07/12 01:57:35 tr Exp $

/**
 * @file
 * Weight quote shipping method administration menu items.
 *
 */

/**
 * Configure the store default product shipping rates.
 *
 * @ingroup forms
 * @see
 *   uc_customquote_admin_method_edit_form_validate()
 *   uc_customquote_admin_method_edit_form_delete()
 *   uc_customquote_admin_method_edit_form_submit()
 */
function uc_customquote_admin_method_edit_form($form, &$form_state, $mid = 0) {
  $form = array();
	drupal_add_js(drupal_get_path('module','uc_customquote').'/uc_customquote.js');
	
  if (is_numeric($mid) && ($method = db_query("SELECT * FROM {uc_customquote_methods} WHERE mid = :mid", array(':mid' => $mid))->fetchObject())) {
    $form['mid'] = array('#type' => 'value', '#value' => $mid);
  }
  else {
    $method = (object) array(
      'title' => '',
      'label' => '',
      'firstunit' => 0,
      'continueunit' => 0,
	  'firstprice' => 0,
	  'continueprice' => 0,
	  'expression' => '',
	  'useexp' => '',
	  'protect' => '',
	  'protect_rate' => 0,
	  'protect_minprice' => 0,
    );
  }
  $form['title'] = array(
    '#type' => 'textfield',
    '#title' => t('后台名称'),
    '#description' => t('在管理界面使用的配送方式名称.'),
    '#default_value' => $method->title,
  );
  $form['label'] = array(
    '#type' => 'textfield',
    '#title' => t('前台名称'),
    '#description' => t('显示给客户的配送方式名称.'),
    '#default_value' => $method->label,
  );
	$form['weight'] = array(
    '#type' => 'fieldset',
    '#title' => t('重量设置'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
	);
  
	$form['weight']['firstunit'] = array(
    '#type' => 'textfield',
    '#title' => t('首重重量'),
	'#description' => t('保留三位有效数字'),
    '#default_value' => number_format($method->firstunit,3),
    '#size' => 16,
    '#field_suffix' =>  'kg',
  );
	$form['weight']['continueunit'] = array(
    '#type' => 'textfield',
    '#title' => t('续重单位'),
		'#description' => t('保留三位有效数字'),
    '#default_value' => number_format($method->continueunit,3),
    '#size' => 16,   
    '#field_suffix' => 'kg',
  );
	$form['fee'] = array(
    '#type' => 'fieldset',
    '#title' => t('配送费用'),
    '#collapsible' => TRUE,
		'#collapsed' => TRUE,
   
	);
	$form['fee']['firstprice'] = array(
    '#type' => 'textfield',
    '#title' => t('首重费用'),
		'#description' => t('保留两位有效数字'),
    '#default_value' => number_format($method->firstprice,2),
    '#size' => 16,
   
  );
	$form['fee']['continueprice'] = array(
    '#type' => 'textfield',
    '#title' => t('续重费用'),
		'#description' => t('保留两位有效数字'),
    '#default_value' => number_format($method->continueprice,2),
    '#size' => 16,
    //'#field_prefix' => '',
    
  );
	$form['fee']['expression'] = array(
    //'#type' => 'textfield',
		'#type' => 'hidden',
    '#title' => t('运费计算公式'),
    '#default_value' => $method->expression,
    '#size' => 16,
  );
	
	$form['fee']['useexp'] = array(
    //'#type' => 'checkbox',
		'#type' => 'hidden',
    '#title' => t('使用公式'),
    '#default_value' => $method->useexp,
    	
  );
	
	$form['protect'] = array(
    '#type' => 'checkbox',
    '#title' => t('支持物流保价'),
    '#default_value' => $method->protect,
   
  );
	$form['prot'] = array(
    '#type' => 'fieldset',
    '#title' => t('保价设置'),
    '#collapsible' => TRUE,
		'#attributes'=>array(
			'id' => 'edit-prot-wrapper',
		),
	);
	$form['prot']['protect_rate'] = array(
    '#type' => 'textfield',
    '#title' => t('保价费率'),
		'#description' => t('保留两位有效数字'),
    '#default_value' => number_format($method->protect_rate,2),
    '#size' => 16,
    '#field_suffix' => '%',
  );
  $form['prot']['protect_minprice'] = array(
    '#type' => 'textfield',
    '#title' => t('最低保价费'),
		'#description' => t('保留两位有效数字'),
    '#default_value' => number_format($method->protect_minprice,2),
    '#size' => 16,
  );

  $form['buttons']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
  );
  $form['buttons']['delete'] = array(
    '#type' => 'submit',
    '#value' => t('Delete'),
    '#submit' => array('uc_customquote_admin_method_edit_form_delete'),
  );

  return $form;
}

/**
 * @see uc_customquote_admin_method_edit_form()
 */
function uc_customquote_admin_method_edit_form_validate($form, &$form_state) {
  if ($form_state['values']['op'] == t('Submit')) {
    if (!empty($form_state['values']['firstunit']) && !is_numeric($form_state['values']['firstunit'])) {
      form_set_error('firstunit', t('首重重量必须是一个数字.'));
    }	
		if (!empty($form_state['values']['continueunit']) && !is_numeric($form_state['values']['continueunit'])) {
      form_set_error('continueunit', t('续重单位必须是一个数字.'));
    }	
		if (!empty($form_state['values']['firstprice']) && !is_numeric($form_state['values']['firstprice'])) {
      form_set_error('firstprice', t('首重费用必须是一个数字.'));
    }	
		if (!empty($form_state['values']['continueprice']) && !is_numeric($form_state['values']['continueprice'])) {
      form_set_error('continueprice', t('续重费用必须是一个数字.'));
    }
		if (!empty($form_state['values']['protect_rate']) && !is_numeric($form_state['values']['protect_rate'])) {
      form_set_error('protect_rate', t('保价费率必须是一个数字.'));
    }
		if (!empty($form_state['values']['protect_minprice']) && !is_numeric($form_state['values']['protect_minprice'])) {
      form_set_error('protect_minprice', t('最低保价费必须是一个数字.'));
    }
    
  }
}

/**
 * @see uc_customquote_admin_method_edit_form()
 */
function uc_customquote_admin_method_edit_form_delete($form, &$form_state) {
  drupal_goto('admin/store/settings/quotes/customquote/'. $form_state['values']['mid'] .'/delete');
}

/**
 * @see uc_customquote_admin_method_edit_form()
 */
function uc_customquote_admin_method_edit_form_submit($form, &$form_state) {
  if (isset($form_state['values']['mid'])) {
	drupal_write_record('uc_customquote_methods', $form_state['values'], 'mid');
    drupal_set_message(t("配送方式已更新."));
	$form_state['redirect'] = 'admin/store/settings/quotes/methods';
  }
  else {
    drupal_write_record('uc_customquote_methods', $form_state['values']);
    // Ensure Rules picks up the new condition.
    entity_flush_caches();
	
    drupal_set_message(t("创建并启用了新的配送方式."));
	
	$form_state['redirect'] = 'admin/store/settings/quotes/manage/get_quote_from_customquote_' . $form_state['values']['mid'];
  }
}
function uc_customquote_admin_method_zones_form($form, &$form_state, $mid = 0){
	$form = array();
	//drupal_add_js(drupal_get_path('module','uc_customquote').'/uc_customquote.js');
	
  if (is_numeric($mid) && ($method = db_query("SELECT * FROM {uc_customquote_methods} WHERE mid = :mid", array(':mid' => $mid))->fetchObject())) {
    $form['mid'] = array('#type' => 'value', '#value' => $mid);
  }else{
		drupal_goto('admin/store/settings/quotes/methods');
	}
	
	$sql = "SELECT * FROM {uc_zones} WHERE zone_country_id = :zone_country_id ORDER BY zone_id ";
	$zone_country_id = 156; //中国的国家代码
	$result = db_query($sql,array('zone_country_id' => $zone_country_id));
	while($zone = $result->fetchObject()){
		$check_sql = "SELECT * FROM {uc_customquote_zones} WHERE zone_id = :zone_id AND mid = :mid";
		$uc_customquote_zone = db_query($check_sql, array('zone_id' => $zone->zone_id, 'mid' => $mid))->fetchObject();
		if($uc_customquote_zone){
			$default_firstprice = $uc_customquote_zone->firstprice;
			$default_continueprice = $uc_customquote_zone->continueprice;
			$default_expression = $uc_customquote_zone->expression;
			$default_useexp = $uc_customquote_zone->useexp;
		}else{
			$default_firstprice = $method->firstprice;
			$default_continueprice = $method->continueprice;
			$default_expression = $method->expression;
			$default_useexp = $method->useexp;
		}
		$form['zone'][$zone->zone_id] = array(
        '#type' => 'fieldset',
				'#collapsible' => TRUE,
				'#collapsed' => TRUE,
        '#title' => $zone->zone_name,
    );
		
		
		$form['zone'][$zone->zone_id]['firstprice_'.$zone->zone_id] = array(
    '#type' => 'textfield',
    '#title' => t('首重费用'),
		'#description' => t('保留两位有效数字'),
    '#default_value' => number_format($default_firstprice,2),
    '#size' => 16,
   
		);
		$form['zone'][$zone->zone_id]['continueprice_'.$zone->zone_id] = array(
			'#type' => 'textfield',
			'#title' => t('续重费用'),
			'#description' => t('保留两位有效数字'),
			'#default_value' => number_format($default_continueprice,2),
			'#size' => 16,
			//'#field_prefix' => '',
			
		);
		$form['zone'][$zone->zone_id]['expression_'.$zone->zone_id] = array(
			//'#type' => 'textfield',
			'#type' => 'hidden',
			'#title' => t('运费计算公式'),
			'#default_value' => $default_expression,
			'#size' => 16,
			//'#attributes' => array('style' => 'display:none;'),
		);
		
		$form['zone'][$zone->zone_id]['useexp_'.$zone->zone_id] = array(
			//'#type' => 'checkbox',
			'#type' => 'hidden',
			'#title' => t('使用公式'),
			'#default_value' => $default_useexp,
			'#attributes' => array('display' => 'none'),
				
		);
	}
	
	$form['buttons']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('保存'),
  );
  
	return $form;
}
function uc_customquote_admin_method_zones_form_validate($form, &$form_state) {
	$sql = "SELECT * FROM {uc_zones} WHERE zone_country_id = :zone_country_id ORDER BY zone_id ";
	$zone_country_id = 156; //中国的国家代码
	$result = db_query($sql, array(':zone_country_id' => $zone_country_id));
	
	while($zone = $result->fetchObject()){
		if (!empty($form_state['values']['firstprice_'.$zone->zone_id]) && !is_numeric($form_state['values']['firstprice_'.$zone->zone_id])) {
			form_set_error('firstprice_'.$zone->zone_id, t('首重费用必须是一个数字.'));
		}	
		if (!empty($form_state['values']['continueprice_'.$zone->zone_id]) && !is_numeric($form_state['values']['continueprice_'.$zone->zone_id])) {
			form_set_error('continueprice_'.$zone->zone_id, t('续重费用必须是一个数字.'));
		}
	}
  
}

function uc_customquote_admin_method_zones_form_submit($form, &$form_state) {
	$sql = "SELECT * FROM {uc_zones} WHERE zone_country_id = :zone_country_id ORDER BY zone_id ";
	$zone_country_id = 156; //中国的国家代码
	$result = db_query($sql, array(':zone_country_id' => $zone_country_id));
	$mid = $form_state['values']['mid'];
	while($zone = $result->fetchObject()){
		$zone_id = $zone->zone_id;
		$count_sql = "SELECT * FROM {uc_customquote_zones} WHERE zone_id = :zone_id AND mid = :mid";
		$count = db_query($count_sql, array(':zone_id' => $zone_id, ':mid' => $mid))->rowCount();
		if($count){
			db_update('uc_customquote_zones')
			  ->fields(array(
				'firstprice' => $form_state['values']['firstprice_'.$zone_id],
				'continueprice' => $form_state['values']['continueprice_'.$zone_id],
				'useexp' => $form_state['values']['useexp_'.$zone_id],
				'expression' => $form_state['values']['expression_'.$zone_id],
			   ))
			   ->condition('zone_id', $zone_id)
			   ->condition('mid', $mid)
			   ->execute();
			
		}
		else{
			db_insert('uc_customquote_zones')
			  ->fields(array(
			    'zone_id' =>  $zone_id,
				'mid' =>  $form_state['values']['mid'],
				'firstprice' => $form_state['values']['firstprice_'.$zone_id],
				'continueprice' => $form_state['values']['continueprice_'.$zone_id],
				'useexp' => $form_state['values']['useexp_'.$zone_id],
				'expression' => $form_state['values']['expression_'.$zone_id],
			   ))
			   ->execute();
			
		}
	}
    drupal_set_message(t("各省份的的具体配送费用保存成功."));
	$form_state['redirect'] = 'admin/store/settings/quotes/methods';
}


/******************************************************************************
 * Menu Callbacks                                                             *
 ******************************************************************************/

/**
 * Confirm deletion of a weight-based shipping method.
 *
 * @see uc_customquote_admin_method_confirm_delete_submit()
 */
function uc_customquote_admin_method_confirm_delete($form, &$form_state, $mid) {
  $form = array();
  $form['mid'] = array('#type' => 'value', '#value' => $mid);

  return confirm_form($form, t('你确实想要删除这个配送方式么?'),
    'admin/store/settings/quotes/methods',
    t('这将会删除这个配送方式，及相关的有条件的动作预设置，以及相关的区域设置. 此操作将无法撤销.'),
    t('删除'));
}

/**
 * @see uc_customquote_admin_method_confirm_delete()
 */
function uc_customquote_admin_method_confirm_delete_submit($form, &$form_state) {
  $mid = $form_state['values']['mid'];
  db_delete('uc_customquote_methods')
    ->condition('mid', $mid)
    ->execute();
  db_delete('uc_customquote_zones')
    ->condition('mid', $mid)
    ->execute();
  rules_config_delete(array('get_quote_from_customquote_' . $mid));

  drupal_set_message(t('配送方式已删除.'));
  $form_state['redirect'] = 'admin/store/settings/quotes/methods';
}
